"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.resolveChain = void 0;
const core_1 = require("@angular-devkit/core");
const custom_webpack_builder_1 = require("@angular-builders/custom-webpack/dist/custom-webpack-builder");
const setup = (options, workspaceRoot, target) => {
    const root = core_1.normalize(workspaceRoot);
    const config = options.customWebpackConfig;
    return (base, path) => {
        return custom_webpack_builder_1.CustomWebpackBuilder.buildWebpackConfig(root, Object.assign(Object.assign({}, config), { path }), base, options, target);
    };
};
function resolveChain(options, workspaceRoot, target, baseWebpackConfig) {
    return __awaiter(this, void 0, void 0, function* () {
        const { chain } = options.customWebpackConfig;
        const build = setup(options, workspaceRoot, target);
        return (chain !== null && chain !== void 0 ? chain : []).reduce((base, path) => __awaiter(this, void 0, void 0, function* () { return build(yield base, path); }), Promise.resolve(baseWebpackConfig));
    });
}
exports.resolveChain = resolveChain;
//# sourceMappingURL=resolve-chaining.js.map